	Procedure funlib
	
	Function nubrowse
	parameters vrecno,vfile,vindex,vfields,vheader,vtitle,vsearch,vwidth,vheight,vbuttons,vtophead,vudf
	*
	*   Jim Jewett  Revision 1.2, 11/12/93
	*
	*	Nubrowse goes to the public as is, no warranties expressed, implied, or
	*	otherwise are made.  No liability is assumed, or held by the author
   	*	for any consequences resulting from the use of Nubrowse in any way. 
	*
 	*   Nubrowse is shareware - feel free to use it in your applications.
	*   Registration fee :
	*   US $ 10   [about the same as the cost of a backordered magazine]
	*
	*   J. Jewett
	*   c/o Nubrowse
	*   1872 Pueblo Pass
	*   Evansville, In  47715
	*
	*   BEFORE YOU USE THIS ROUTINE: You must download file Jkey.exe from
	*   the 3rd Party Products library of Foxforum. This product will NOT run without Jkey.
	*
	*  Many thanks go to:
	*	Joe Gotthelf:  Author of Jkey. Without his routine, this one would not be possible.
	*	Mitch Muroff  [MSFT]: Provided key code inspiration at a critical moment.
	*	Max Riester: Without him, I wouldn't have known that this method was possible.
	*    All the others who have helped in the testing process.
	*
	* Incremental browse with menu buttons.
	* Tab key activates and uses bottom menu.
	* Solid bar selection menu appears at bottom.
	* Enter selects the record.
	* Esc exits the routine [except when in bottom menu].
	* Shift-Tab reciprocates between search screen and menu bar.
	*
	*
	*  11/12/93   I just installed provisions for double click. It seems to work OK. Please
	*			   let me know if it can be improved.
	*
	* Future Plans:
	*
	*   ...So far, I am still trying to trap for ctrl+w, ctrl+end and ctrl+q. It seems that Jkey
	*      automatically shuts itself off. Attempts to override this are crude and still under
	*      construction. If you have any ideas, please let me know.
	*
	*   ...I am considering providing the option of a menu bar either at the top, bottom, left or right.
	*		added to funlib.prg
	*
	*   ...Since the current methodology uses two windows [for numerous technical reasons],
	*      I am still trying to see if I can BOTH maximize and minimize both windows by changing
	*      either one. 
	*		 added to funlib.prg
	*
	*   ... I hope to include some text which explains the keystrokes. Perhaps another window....
	*
	*   ...And miles to go before I sleep.....
	*	
	*
	* vrecno  = record number which browse should start at [permits return to a particular position]
	* vfile 	   = file name
	* vindex  = index[es] to search on. I currently default to the "old idx" methodology. Feel
	*                free to update this to your "cdx" method.
	* vfields  =	listing of field names. Separated by a '+' will provide a solid bar, separated by ','
	*			will individualize fields.
	* vheader= appears in title [header] of list box
	* vtitle     = title of master browse window
	* vsearch = prompt for Jkey search text
	* vwidth   = width of master search window
	* vheight   = height of master browse window
	* vbuttons= text which should appear on option menu push buttons. Separate with a ';' [semicoln]
	* 			 program will handle button descriptions 15-16 characters long.
	* Special note: Program code automatically assumes that the first button will be 'OK' and that
	* 				the second button will be 'Cancel'. The following buttons are based on your
	*				definition.
	* vtophead = how many lines will appear above browse window. This is so that additional	
	*			    text can appear [i.e. via udf].
	* vudf         = provision to run udf [user defined function].

	* establish working environment.
	SET BELL OFF
	modify window screen font "foxfont", 9 style "N"
	*
	store -1 to m.g_lastrow, m.g_lastcol, m.g_lastcllk
	on key label leftmouse do i_dblclk
	stor .f. to tok,tesc
	on key label esc do fesc
      on key label enter do fenter
	on key label rightmouse keyboard "{enter}"
	on key label tab do tabit
	on key label backtab keyboard "{ctrl+f1}"
	on key label ctrl+w do knull
	on key label ctrl+q do knull
	on key label ctrl+end do knull
	CLEAR
	SET TALK OFF
	SET SAFE OFF
	*
	use (vfile)
	set index to (vindex)
	*
	* Provision to return to a given place in the file. This is nice when you want to return
	* to a given place in the browse.
	if vrecno=0
		goto top
	else
		goto vrecno
	endi
	*
	* calculate starting and ending positions for master window based upon width selected
	* need up update to "handle" left and right menus
	vremain=80-vwidth
	vleft=(vremain/2)
	vright=vleft+vwidth
	*
	DEFINE WINDOW brmother  FROM 0,vleft TO vheight,vright   float grow minimize title (vtitle) font "ms sans seriff",12
	activate window brmother
*	define window vmessage from 20,1 to 23,rightside-1 nofloat grow none in window brmother
*	activate window vmessage in brmother
*  	@ vheight-9,5 say '[Tab] = Menu        [Shift-Tab] = Search/Menu        [Enter]=Select        [Esc]=Exit'
	set library to jkey additive
*	activate window brmother
	@ vtophead-1,1 say vsearch font "ms sans seriff",12 
	_jdblclick=-1

	=JKEYINIT("U","","*")  &&,m.brwintit)  && see JKEY25.exe by Joe Gotthelf on
                                   && Compuserve 74017,3670
 	set talk off 

	if vtophead<1
         vtophead=1
 	endi
*	DEFINE WINDOW mybrow FROM vtophead,0 TO vheight-7.5,vwidth-3 nofloat grow in window brmother TITLE ' ' &&FONT  "MS SANS SERIFF",6
	DEFINE WINDOW mybrow FROM vtophead,0 TO vheight-(vtophead+3),vwidth-3 nofloat grow in window brmother TITLE ' ' &&FONT  "MS SANS SERIFF",6

	* establish appearance of header for search listing
	if len(vheader)=0
		sheader=' '
 	else
 		sheader=vheader
 	endi

 	BROWSE WINDOW mybrow in window brmother nomenu font "foxfont",12  NOWAIT nodelete FIELDS aa=&vfields:v=myvalid():F:w=mywhen():h=sheader

	* calculate size of needed control window
	* horizontal window
	* program automatically places OK in first position, and Cancel in second position.
	* this is important because the program specifically uses the positions when {enter} and
	* {escape} are selected in the browse window.
	vbuttons='OK;Cancel;'+vbuttons
	vbuttlen=len(vbuttons)
	* first calculate number of buttons needed
	numbutt=1
	for i=1 to vbuttlen
		if subs(vbuttons,i,1)=';'
			numbutt=numbutt+1
		endi
	next
	*	
	vbuttwin=(numbutt*14)
      vbuttwin=vbuttwin+((numbutt-1)*2)
	* calculate starting and ending positions for master window based upon width selected
	* need up update to "handle" left and right menus
	cremain=80-vbuttwin
	cleft=(cremain/2)
	cright=cleft+vbuttwin	

	
	mone = ""
	DEFINE WINDOW control ;
		from 29,cleft to 37,cright;
		FONT "ms sans seriff",12;
		none ;
		COLOR RGB(,,,0,0,128);
		FLOAT ;
		NOCLOSE ;
		MINIMIZE TITLE " Option Menu "
		activate window control

	texit=.f.
	do whil .t.
		keyboard "{ctrl+f1}"
		keyboard "{ctrl+f1}"
 		@ 1,2 GET mbutton function '*H'  PICTURE vbuttons size 1.5,15,6  VALID vbutton() DEFAULT 2  FONT "ms sans seriff",11 
		READ CYCLE
	      if texit
      	   exit
	      endi			
	endd
      =jkeycanc()
      keyboard "{ctrl+w}"
      release window control
      release window mybrow
      release window brmother
	on key label esc
	on key label enter
	on key label leftmouse
	on key label rightmouse
	on key label backtab
      on key label tab
	on key label ctrl+w
	on key label ctrl+q
	on key label ctrl+end
	=JKEYCANC()
	RETURN mbutton

FUNCTION vbutton
* value will be returned by function
if mbutton>=1.and.mbutton<=numbutt
   texit=.t.
endi
RETURN .T.

 FUNCTION mywhen
parameters twhen
on key label tab do tabit
on key label enter do fenter

checkrow=recno()

activate window brmother
aa=sayit()
*@ 14,5 say '[Tab] = Menu        [Shift-Tab] = Search/Menu        [Enter]=Select        [Esc]=Exit'
entsw2=.t.

*
* test code in progress
*if wminimum('control')
*	zoom window brmother min
*	hide window brmother
*endi
*if wmaximum('control')
*	zoom window brmother max
*	activate window brmother	
*endi
* 	mone = operator+reg
*return mone
 RETURN .T.

 FUNCTION myvalid
	RetVal = .T.
 RETURN .T.

function tabit
parameters tabit
if wontop('control')
	on key label tab
	keyboard "{tab}"
else
      keyboard "{ctrl+f1}"     
endi
return .t.

function fenter
parameters fenterv
if wontop('control')
	on key label enter
	keyboard "{enter}"
else
      keyboard "{ctrl+f1}"     
	keyboard "{enter}"
endi
return .t.

function fesc
parameters tabit
if wontop('control')
*      KEYBOARD "{CTRL+F1}"
 *     KEYBOARD "{ESC}"
else
      keyboard "{ctrl+f1}"     
	keyboard "{rightarrow}"
	on key label enter
	keyboard "{enter}"
endi
return .t.

function stuff
parameters ts
* just a little "junk" routine which helps during testing
*? chr(7)
return 'hello'

function sayit
parameters ttt
* This little routine will call the program of your choice, i.e. test.spr, or test.prg
* and allow you to do things such as display additional descriptive information in the
* box above the browse screen. 
do (vudf)
return .t.

procedure i_dblclk
*
private all like l_*
* added 11/12/93
l_toprow = 1
l_lastrow=l_toprow+wrows("mybrow")
l_left = 1
l_right = vwidth
stor 0 to l_mrow,l_mcol
l_mrow=mrow("mybrow")
l_mcol=mcol("mybrow")
l_sec=seconds() 
*
if between(l_mrow, l_toprow, l_lastrow) .and. between(l_mcol, l_left, l_right)
if mrow() # m.g_lastrow or ;
   mcol() # m.g_lastcol or ;
   (seconds() - g_lastcllk) > _DBLCLICK
	m.g_lastrow = mrow()
	m.g_lastcol = mcol()
	m.g_lastcllk = seco()
else
	**** same row and col within _DBLCLICK seconds!
	keyboard "{enter}"
endif
endi





function knull
parameters vnull
* reset Jkey since it automatically shuts off with ctrl+q, ctrl+end, etc. options.
activate window brmother
@ vtophead-1,1 say vsearch font "ms sans seriff",12 
_jdblclick=-1
=JKEYCANC()
=JKEYINIT("U","","*")  &&,m.brwintit)  && see JKEY25.exe by Joe Gotthelf on
                                   && Compuserve 74017,3670
return .t.
                                   

